package prime.toolbox.scomm;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

public class GenerateTOM {

	
	public static void generate(String tomFileName) throws IOException{	
				
		FileWriter outFile = new FileWriter(tomFileName);
		PrintWriter out = new PrintWriter(outFile);
		
		Date now = new Date();
		Format formatter = new SimpleDateFormat("MM-dd-yyyy");
		
				
		String add = "<objectmodel version=\"2.0\" created=\"" + formatter.format(now) + "\" dateformat=\"MM-dd-yyyy\">";
		out.println(add);
		out.println();
		out.flush();	
		
		final String[] names = {
		// 	prime.game.dataobjects	
				"prime.game.dataobjects.Area",	
				"prime.game.dataobjects.Building",
				"prime.game.dataobjects.BuildingType",
				"prime.game.dataobjects.BusinessUnit",
				"prime.game.dataobjects.Clause",
				"prime.game.dataobjects.Contract",
				"prime.game.dataobjects.Diagram",
				"prime.game.dataobjects.DurationClause",
				"prime.game.dataobjects.FunctionalUnit", 			
			//	"prime.game.dataobjects.Image",		
			//   the objects has mehod getIImage and use the interface
				"prime.net.dataobjects.IImage",
				
				
				"prime.game.dataobjects.OperationProcess",
		//	     this interface is not implemented yet		
		//		"prime.net.dataobjects.IOperationProcessField",
				"prime.game.dataobjects.PenaltyClause",
				"prime.game.dataobjects.Player",
				"prime.game.dataobjects.PlayerProfile",
				"prime.game.dataobjects.ProductClause",
				"prime.game.dataobjects.ProductContract",
				"prime.game.dataobjects.ProjectClause",
				"prime.game.dataobjects.ProjectContract",
				"prime.game.dataobjects.Region",
			//  this interface is not implemented yet	
				"prime.game.dataobjects.Report",
				"prime.game.dataobjects.ResourceContract",
				"prime.game.dataobjects.Sale",
				"prime.game.dataobjects.ServerMessage",
				"prime.game.dataobjects.ServiceContract",
				"prime.game.dataobjects.SimulationEntry",
				"prime.game.dataobjects.Site",
				"prime.game.dataobjects.Tender",
				"prime.game.dataobjects.TrustContract",
				"prime.game.dataobjects.UserEmail",
				"prime.game.dataobjects.VBE", 
				
			//prime.game.dataobjects.development
				"prime.game.dataobjects.development.DevelopmentUnit",
		//		"prime.net.dataobjects.development.IOPDevelopment",
				"prime.game.dataobjects.development.OPResearch",
				
			//prime.net.dataobjects.distribution
				"prime.game.dataobjects.distribution.DistributionUnit",
				"prime.game.dataobjects.distribution.OPLogistics",
				"prime.game.dataobjects.distribution.Route",
				"prime.game.dataobjects.distribution.Service",
				"prime.game.dataobjects.distribution.Supplier",
				"prime.game.dataobjects.distribution.TransportationMean",
				
			//prime.net.dataobjects.finance
				"prime.game.dataobjects.finance.Account",
				"prime.game.dataobjects.finance.Accountancy",
				"prime.game.dataobjects.finance.Auction",
				"prime.game.dataobjects.finance.AuctionBid",
				"prime.game.dataobjects.finance.BankClient",
				"prime.game.dataobjects.finance.BankTransfer",
				"prime.game.dataobjects.finance.CentralBank",
				"prime.game.dataobjects.finance.FinanceUnit",
				"prime.game.dataobjects.finance.Loan",
				"prime.game.dataobjects.finance.LoanPayment",
				"prime.game.dataobjects.finance.LocalBank",
			//  the interface is not implemented	
				"prime.game.dataobjects.finance.OPFinance",
				"prime.game.dataobjects.finance.VirtualAccount",
				
			//prime.net.dataobjects.production	
				"prime.game.dataobjects.production.BOM",
				"prime.game.dataobjects.production.Gateway",
				"prime.game.dataobjects.production.GatewayTemplate",
				"prime.game.dataobjects.production.Machine",
				"prime.game.dataobjects.production.MachineClass",
				"prime.game.dataobjects.production.ManufacturingConnection",
			//  bez IMetaBOM
			//	"prime.net.dataobjects.production.IMetaBOM",
			//	not implemented
				"prime.game.dataobjects.production.OPManufacturing",
			//	"prime.game.dataobjects.production.OPManufacturingBuffer",
				"prime.game.dataobjects.production.OPPM",
				"prime.game.dataobjects.production.OPPortfolio",
				"prime.game.dataobjects.production.OPProject",
				"prime.game.dataobjects.production.Product",
				"prime.game.dataobjects.production.ProductClass",
				"prime.game.dataobjects.production.ProductFamily",
			
				"prime.game.dataobjects.production.ProductionRight",
				"prime.game.dataobjects.production.ProductionUnit",
				"prime.game.dataobjects.production.ProductLifeCycle",
				"prime.game.dataobjects.production.Project",
				"prime.game.dataobjects.production.ProjectTemplate",
				"prime.game.dataobjects.production.Stock",
				"prime.game.dataobjects.production.Task",
				"prime.game.dataobjects.production.TaskTemplate",
				"prime.game.dataobjects.production.Technology",
		
				
				
		//  	prime.game.dataobjects.sales 	
		//		"prime.net.dataobjects.IForecast",
				"prime.game.dataobjects.sales.ExistingMarketForecast",
				"prime.game.dataobjects.sales.NewMarketForecast",
		//		this interface is removed		
		//		"prime.net.dataobjects.sales.IForecastOrder",
		//	     this interface is not implemented yet
				"prime.game.dataobjects.sales.OPSales",
				"prime.game.dataobjects.sales.SalesReport",
				"prime.game.dataobjects.sales.SalesUnit",

		//		prime.game.simulation.crisis
				"prime.game.simulation.crisis.Crisis"
				};
		
		System.out.println("START!!!");
			
		for (int i=0; i<names.length; i++ ){
			addProperty(names[i], out);
			out.println();
		}
		
		
		add = "<object name=\"ISellable\" class=\"prime.game.dataobjects.finance.ISellable\">";
		out.println(add);
		add = "     <property key=\"dummy\" type=\"string\"/>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
		add = "<object name=\"CrisisConsequence\" class=\"prime.game.simulation.crisis.CrisisConsequence\">";
		out.println(add);
		add = "     <property key=\"dummy\" type=\"string\"/>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
		add = "<object name=\"CrisisScope\" class=\"prime.game.simulation.crisis.CrisisScope\">";
		out.println(add);
		add = "     <property key=\"dummy\" type=\"string\"/>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
		add = "<object name=\"CrisisType\" class=\"prime.game.simulation.crisis.CrisisType\">";
		out.println(add);
		add = "     <property key=\"dummy\" type=\"string\"/>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
// 		add definition of Point structure
		add = "<object name=\"Point\" class=\"prime.net.Point\">";
		out.println(add);
		add = "     <property key=\"x\" type=\"int\">";
		out.println(add);
		add = "          <label>X coordinate</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);
		out.println();		
		add = "     <property key=\"y\" type=\"int\">";
		out.println(add);
		add = "          <label>Y coordinate</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
// 		add definition of MachineNeed structure		
		add = "<object name=\"MachineNeed\" class=\"prime.game.dataobjects.production.MachineNeed\">";
		out.println(add);
		add = "     <property key=\"machineClass\" type=\"MachineClass\">";
		out.println(add);
		add = "          <label>Machine class</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);		
		out.println();		
		add = "     <property key=\"number\" type=\"int\">";
		out.println(add);
		add = "          <label>Number</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();
		
// 		add definition of Skill structure			
		add = "<object name=\"Skill\" class=\"prime.net.Skill\">";
		out.println(add);
		add = "     <property key=\"name\" type=\"string\">";
		out.println(add);
		add = "          <label>Name</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);		
		out.println();		
		add = "     <property key=\"level\" type=\"int\">";
		out.println(add);
		add = "          <label>Level</label>";
		out.println(add);
		add = "     </property>";
		out.println(add);
		add = "</object>";
		out.println(add);
		out.println();	
		
		out.println();
		out.println("</objectmodel>");
		out.flush();
		out.close();
		
		System.out.println("\n\nDONE!!!");		
	}
	
	private static void addProperty(String objectClass, PrintWriter out){
		int lastPoint = objectClass.lastIndexOf( '.' );
		String className = objectClass.substring(lastPoint + 1);
		
//		String gameClass = objectClass.replace(".net.", ".game.");
//		lastPoint = gameClass.lastIndexOf( '.' );
//		gameClass = gameClass.substring(0, lastPoint+1).concat(className);
		
		String gameClass = objectClass;
		if (objectClass.equals("prime.net.dataobjects.IImage"))
				gameClass = "prime.game.dataobjects.Image";
		
		String[] split = objectClass.split("\\.");
		String interfaceName = split[split.length - 1];
		
		System.out.println();
		System.out.println( "Methods of object: ".concat( objectClass ) );
						
		ArrayList<Method> getArray = new ArrayList();
		ArrayList<String> setArray = new ArrayList();
		String add = "";
		String type = "";
		
		add = "<object name=\"" + interfaceName + "\" class=\"" + gameClass + "\">";
		out.println(add);
		
	//  object Image does not have an Id field!!	
		if (!objectClass.equals("prime.net.dataobjects.IImage")){
			add = "     <property key=\"Id\" type=\"int\" readonly=\"\" civil=\"\">";
	
			out.println(add);	
	
			add = "          <label>Id</label>";
			out.println(add);
	
			add = "          <description>Id of the object</description>";
			out.println(add);
	
			add = "     </property>";
			out.println(add);		
			
			out.println();
			out.flush();
		}
		
//		add the property IsReccuring of class IDurationCaluse which does not have get method 
		if (interfaceName.equals("DurationClause")){
			add = "     <property key=\"IsRecurring\" type=\"boolean\">";
			out.println(add);	
		
			add = "          <label>Is Recurring</label>";
			out.println(add);
		
			add = "          <description></description>";
			out.println(add);
		
			add = "     </property>";
			out.println(add);		
				
			out.println();
			out.flush();	
		}
		
		try {
			Class objClass = Class.forName( objectClass );
			Method ocm[] = objClass.getMethods(); 
			for ( int i = 0; i < ocm.length; i++ ) {
					
				if ( (ocm[i].getParameterTypes().length == 0
							&& ocm[i].getName().startsWith( "get" ) 
							&& !ocm[i].getName().startsWith("KPI", 3)) ||
					 (ocm[i].getParameterTypes().length == 1
							 && ocm[i].getName().startsWith( "get" )
							 && ocm[i].getParameterTypes()[0].getSimpleName().equals("Session")
							 & !ocm[i].getName().startsWith("KPI", 3))   ){
					getArray.add(ocm[i]);
					
					System.out.println("     " + ocm[i].getName() + " -> " + ocm[i].getReturnType().getSimpleName());			
				}
							
							
				if ( ocm[i].getName().startsWith( "set" )
							&& ocm[i].getParameterTypes().length == 1 ){
					setArray.add(ocm[i].getName());
				}
			}
			
			for (int j=0; j<getArray.size(); j++){
				Method getMethod = getArray.get(j);
				String setMethod = "set".concat(getMethod.getName().substring(3));
				String methodType = getMethod.getReturnType().getSimpleName();
				String methodName = getMethod.getName();
				
				String seq = "";
				String civil = "";
				String reference = "";
				String readonly = "";
				
				
				if (methodName.equals("getId"))
					continue;
				if (methodName.equals("getFieldNames"))
					continue;
				if (methodName.equals("getTypeName"))
					continue;		
				if (methodName.equals("getType"))
					continue;		
				if (methodName.contains("MetaBOM"))
					continue;
				if (methodName.equals("getClass"))
					continue;
				
				if (methodType.equals("Collection"))
					continue;
				if (methodType.equals("HashMap"))
					continue;
				if (methodType.equals("Hashtable"))
					continue;
				if (methodType.equals("HashSet"))
					continue;
				if (methodType.equals("Set"))
					continue;
				if (methodType.equals("ArrayList"))
					continue;
				if (methodType.equals("GatewayStatus"))
					continue;
				if (methodType.equals("TaskStatus"))
					continue;

				if ( methodType.equals( "List" ) ) {
					if ( methodName.equals( "getProductPortfolio" ) || methodName.contains( "ProductsInStock" ) ) {
						methodType = "Product";
					}
					else if ( methodName.contains( "Sites" ) ) {
						methodType = "Site";
					}
					else if ( methodName.contains( "Ops" ) ) {
						methodType = "OperationProcess";
					}
					else if ( methodName.contains( "Regions" ) ) {
						methodType = "Region";
					}
					else if ( methodName.contains( "ProductFamilies" ) ) {
						methodType = "ProductFamily";
					}
					else if ( methodName.contains( "ProductClasses" ) ) {
						methodType = "ProductClass";
					}
					else if ( methodName.contains( "BuildingsUnderConstruction" ) ) {
						methodType = "Building";
					}
					else if ( methodName.contains( "InactiveProjects" ) ) {
						methodType = "Project";
					}
					else if ( methodName.contains( "SimulationEntries" ) ) {
						methodType = "SimulationEntry";
					}
					else if ( methodName.contains( "ActiveTasks" ) ) {
						methodType = "Task";
					}
					else if ( methodName.contains( "ActiveCrises" ) ) {
						methodType = "Crisis";
					}
					else if ( methodName.contains( "IDiagrams" ) ) {
						methodType = "Diagram";
					}
					else if ( methodName.contains( "BUs" ) ) {
						methodType = "BusinessUnit";
					}
					else if ( methodName.contains( "FUs" ) ) {
						methodType = "FunctionalUnit";
					}
					else if ( methodName.contains( "AcceptedProductContracts" ) ) {
						methodType = "ProductContract";
					}
					else if ( methodName.contains( "ProvidedServices" ) ) {
						methodType = "Service";
					}
					else if ( methodName.contains( "Outputs" ) || methodName.contains( "Inputs" ) ) {
						methodType = "OperationProcess";
					}
					else if ( methodName.endsWith( "s" ) )
						methodType = methodName.substring( 3, methodName.length() - 1 );
					else
						methodType = methodName.substring( 3 );
					seq = " seq=\"0\"";
				}
				
				
				if (getMethod.getReturnType().isArray() && 
						!methodType.equals("byte[]")){
					seq = " seq=\"0\"";
					methodType = methodType.substring(0, methodType.length()-2);
				}
				
		//		if (methodType.equals("int"))
		//			methodType = "long";
		//		else if (methodType.equals("double"))
		//			methodType = "float";
				if (methodType.equals("String") || methodType.equals("KPI"))
					methodType = methodType.toLowerCase();
				if (methodType.equals("byte[]"))
					methodType = "binary";
				
				
				if (methodName.substring(3).matches(".*Date.*"))
					methodType = "date";				
				
				if (methodName.substring(3).equals("Name"))
					civil = " civil=\"\"";	
				if (methodName.substring(methodName.length()-2).equals("Id"))
					reference = " reference=\"" + methodName.substring(3, methodName.length()-2) + "\"";
				if (!setArray.contains(setMethod))
					readonly = " readonly=\"\"";
				
				add = "     <property key=\"" + methodName.substring(3) + "\" type=\"" + methodType + "\"" + seq + readonly + civil + reference + ">";
				out.println(add);	
				
		//		if (!setArray.contains(setMethod)){						
		//			add = "     <property key=\"" + methodName.substring(3) + "\" type=\"" + methodType + "\"" + seq + " readonly=\"\"" + civil + ">";
		//			out.println(add);				
		//		}				
		//		else { 						
		//			add = "     <property key=\"" + methodName.substring(3) + "\" type=\"" + methodType + "\"" + seq + civil + ">"; 
		//			out.println(add);	
		//		}
				
				add = "          <label>" + getLabel(methodName.substring(3)) + "</label>";
				out.println(add);
				
				add = "          <description></description>";
				out.println(add);
				
				add = "     </property>";
				out.println(add);		
								
				if (j < (getArray.size() - 4)){
					out.println();
				}
				
				out.flush();				
			}
			
			add = "</object>";
			out.println(add);
			
			out.flush();				
			
		} catch (ClassNotFoundException e) {
			System.out.println("Class not found: " + objectClass);
			e.printStackTrace();
		}		
	}
	
	private static String getLabel(String s){
		int len = s.length();
		String res = "";
		
		for (int i=0; i<len;i++){
			if (Character.toString(s.charAt(i)).equals("I") && i<len-1 && 
					Character.isUpperCase(s.charAt(i+1))){
				continue;
			}
			if (Character.isLowerCase(s.charAt(i)) && i<len-1 && 
					Character.isUpperCase(s.charAt(i+1))){
				res = res + s.charAt(i) + " ";
				continue;
			}
			res = res + s.charAt(i);		
		}
		return res;
	}
	
}
