package prime.toolbox.test;

import org.eclipse.swt.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

/*
 * Scroll a widget into view on focus in
 * 
 * For a list of all SWT example snippets see
 * http://www.eclipse.org/swt/snippets/
 * 
 * @since 3.0
 */

public class TestSWT2 {
	
public static void main (String [] args) {
	Display display = new Display ();
	Shell shell = new Shell (display);
//	shell.setLayout(new GridLayout());
	
	FormLayout dialog_form = new FormLayout ();
	dialog_form.marginWidth = dialog_form.marginHeight = 4;
	dialog_form.spacing = 15;
	shell.setLayout( dialog_form );
	
	final ScrolledComposite sc = new ScrolledComposite(shell, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
//	sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
	
	FormData sc_data = new FormData();
	sc_data.top = new FormAttachment( 10, -15 );
	sc_data.left = new FormAttachment( 20, 0 );
	sc.setLayoutData( sc_data );
	
	
	Composite c = new Composite(sc, SWT.NONE);
//	c.setLayout(new GridLayout(10, true));
	FormLayout c_form = new FormLayout ();
	c_form.marginWidth = dialog_form.marginHeight = 4;
	c_form.spacing = 15;
	c.setLayout( c_form );
	
	
	for (int i = 0 ; i < 1; i++) {
		Button b = new Button(c, SWT.PUSH);
		b.setText("Button "+i);
	//	b.setBounds(60, 20, 60, 20);
		
		FormData okButton_data = new FormData();
		okButton_data.top = new FormAttachment( 80, -15 );
		okButton_data.left = new FormAttachment( 20, 0 );
		b.setLayoutData( okButton_data );
		
	}
	sc.setContent(c);
	sc.setExpandHorizontal(true);
	sc.setExpandVertical(true);
	sc.setMinSize(c.computeSize(SWT.DEFAULT, SWT.DEFAULT));

	Listener listener = new Listener() {
		public void handleEvent(Event e) {
			Control child = (Control)e.widget;
			Rectangle bounds = child.getBounds();
			Rectangle area = sc.getClientArea();
			Point origin = sc.getOrigin();
			if (origin.x > bounds.x) origin.x = Math.max(0, bounds.x);
			if (origin.y > bounds.y) origin.y = Math.max(0, bounds.y);
			if (origin.x + area.width < bounds.x + bounds.width) origin.x = Math.max(0, bounds.x + bounds.width - area.width);
			if (origin.y + area.height < bounds.y + bounds.height) origin.y = Math.max(0, bounds.y + bounds.height - area.height);
			sc.setOrigin(origin);
		}
	};
	Control[] controls = c.getChildren();
	for (int i = 0; i < controls.length; i++) {
		controls[i].addListener(SWT.Activate, listener);
	}

	shell.setSize(300, 500);
	shell.open ();
	while (!shell.isDisposed ()) {
		if (!display.readAndDispatch ()) display.sleep ();
	}
	display.dispose ();
}
}