package prime.toolbox.test;

import prime.toolbox.ObjectDef;
import prime.toolbox.PropertyDef;
import prime.toolbox.ObjectCollection;
import prime.toolbox.xml.reader.Reader;
import prime.toolbox.xml.reader.ReaderException;


/*
 * This is a test example. It does this:
 * 
 * 1. creates a toolbox XML reader and reads TOM.XML
 * 2. prints out the contents of all objects
 * 3. prints the number of defined objects
 * 4. prints a list of all objects which have a property of type 'REGION'
 * 
 * @author      Pavel Boytchev
 * @version     1.4, 2006-08-21
 */
public class TestXMLReader {

	public static void main(String[] args) {
		try
		{
			Reader xmlReader = new Reader("prime/toolbox/test/tom11.xml");
			ObjectCollection objects = xmlReader.getObjects();
			
			System.out.println("TestXMLReader");
			System.out.println("  TOM version: "+xmlReader.getVersion());
			System.out.println("  TOM date format: "+xmlReader.getDateFormat());
			System.out.println();
			System.out.println(objects.stringOf());
			System.out.println("Objects defined: "+objects.size());
			System.out.println("List of all objects which have a property of type 'REGION':");
			for( int objIdx=0; objIdx<objects.size(); objIdx++)
			{
				ObjectDef object=objects.getObjectDef(objIdx);
				for( int propIdx=0; propIdx<object.size(); propIdx++)
				{
					PropertyDef prop = object.getPropertyDef(propIdx); 
					if (prop.getType().equals("REGION"))
					{
						System.out.println("   object '"+object.getName()+"' property '"+prop.getName()+"'");
						break;
					}
				}
			}
		}
		catch(ReaderException txre)
		{
			System.err.println( txre.getMessage() );
		}
	}
};


